#include "mainwindow.h"
#include "ui_mainwindow.h"
#include <qdebug.h>
#include <math.h>

MainWindow::MainWindow(QWidget *parent) :
    QMainWindow(parent),
    ui(new Ui::MainWindow)
{
    ui->setupUi(this);
}

MainWindow::~MainWindow()
{
    delete ui;
}

void MainWindow::on_pushButton_clicked()
{

          float circle_center_x = 8;
          float circle_center_y = 1;
          float radius = 5;

          float line_x1 = 1;
          float line_y1 = 1;
          float line_x2 = 10;
          float line_y2 = 6;

          float dx, dy, A, B, C, det, t;

          dx = line_x2 - line_x1;
          dy = line_y2 - line_y1;

          A = dx * dx + dy * dy;
          B = 2 * (dx * (line_x1 - circle_center_x) + dy * (line_y1 - circle_center_y));
          C = (line_x1 - circle_center_x) * (line_x1 - circle_center_x) + (line_y1 - circle_center_y) * (line_y1 - circle_center_y) - radius * radius;

          det = B * B - 4 * A * C;
          if ((A <= 0.0000001) || (det < 0))
          {

              qDebug() << "No real solutions";

          }
          else if (det == 0)
          {

              t = -B / (2 * A);
              float intersection_x1 = (line_x1 + t * dx);
              float intersection_y1 = (line_y1 + t * dy);

              qDebug() << "One solution x1 :" << intersection_x1 << "y1 :" << intersection_y1;
          }
          else
          {

              t = (-B + sqrt(det)) / (2 * A);
              float intersection_x1 = (line_x1 + t * dx);
              float intersection_y1 = (line_y1 + t * dy);

              t = (-B - sqrt(det)) / (2 * A);
              float intersection_x2 = (line_x1 + t * dx);
              float intersection_y2 = (line_y1 + t * dy);

              qDebug() << "Two solutions x1 :" << intersection_x1 << "y1 :" << intersection_y1;
              qDebug() << "Two solutions x2 :" << intersection_x2 << "y2 :" << intersection_y2;
          }


}

void MainWindow::on_pushButton_2_clicked()
{
            float circle_center_x = 75;
            float circle_center_y = 75;
            float radius = 17.5;

            float line_x1 = 53.5;
            float line_y1 = 103.5;
            float line_x2 = 69.7;
            float line_y2 = 87.4;

            float dx, dy, A, B, C, det, t;

            dx = line_x2 - line_x1;
            dy = line_y2 - line_y1;

            A = dx * dx + dy * dy;
            B = 2 * (dx * (line_x1 - circle_center_x) + dy * (line_y1 - circle_center_y));
            C = (line_x1 - circle_center_x) * (line_x1 - circle_center_x) + (line_y1 - circle_center_y) * (line_y1 - circle_center_y) - radius * radius;

            det = B * B - 4 * A * C;
            if ((A <= 0.0000001) || (det < 0))
            {

                qDebug() << "No real solutions";

            }
            else if (det == 0)
            {

                t = -B / (2 * A);
                float intersection_x1 = (line_x1 + t * dx);
                float intersection_y1 = (line_y1 + t * dy);

                qDebug() << "One solution x1 :" << intersection_x1 << "y1 :" << intersection_y1;
            }
            else
            {

                t = (-B + sqrt(det)) / (2 * A);
                float intersection_x1 = (line_x1 + t * dx);
                float intersection_y1 = (line_y1 + t * dy);

                t = (-B - sqrt(det)) / (2 * A);
                float intersection_x2 = (line_x1 + t * dx);
                float intersection_y2 = (line_y1 + t * dy);

                qDebug() << "Two solutions x1 :" << intersection_x1 << "y1 :" << intersection_y1;
                qDebug() << "Two solutions x2 :" << intersection_x2 << "y2 :" << intersection_y2;
            }
}
